"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = buildCompScripts;

var _forEach = _interopRequireDefault(require("@arijs/frontend/isomorphic/utils/for-each"));

var _streamXmlParser = _interopRequireDefault(require("@arijs/stream-xml-parser"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var reTrimEnd = /\s+$/;
var reSlashStart = /^\/*/;
var printTreeAsync = _streamXmlParser["default"].printerTransform.printTreeAsync;

function buildScriptComp(item, elAdapter) {
  var script = elAdapter.initName('script'); // if (!item.opt?.jsRel) {
  // 	console.error(' ~  pathJsRel not found in', Object.keys(item.opt || item));
  // }

  var path = String(item.opt.jsRel).replace(reSlashStart, '/');
  elAdapter.attrsAdd(script, {
    name: 'src',
    value: path
  });
  return script;
}

function buildScriptRender(item, compile) {
  var compiled = compile(item.html.data, {
    prefixIdentifiers: true
  }).code;
  var script = "\n\tassembleComponent(".concat(JSON.stringify(item.comp), ", ").concat(JSON.stringify(item.opt.path), ", function() {").concat(compiled, ";});\n");
  return script;
}

function buildScriptInitialState(state) {
  var script = "\n\tglobal.services.initialState = ".concat(JSON.stringify(state), ";\n");
  return script;
}

function buildCompScripts(_ref) {
  var list = _ref.list,
      elAdapter = _ref.elAdapter,
      jsGlobalVar = _ref.jsGlobalVar,
      jsInitialState = _ref.jsInitialState,
      compile = _ref.compile,
      formatJs = _ref.formatJs,
      cbTree = _ref.callback;
  var scripts = elAdapter.initRoot();
  var render = '';
  (0, _forEach["default"])(list, function (item) {
    elAdapter.childElement(scripts, buildScriptComp(item, elAdapter));
    render += buildScriptRender(item, compile);
  });
  render += buildScriptInitialState(jsInitialState);
  scripts = elAdapter.childrenGet(scripts);
  return printTreeAsync({
    tree: scripts,
    elAdapter: elAdapter,
    path: [],
    level: 1,
    callback: withPrinted
  });

  function withPrinted(printErr, scripts) {
    if (printErr) return cbTree(printErr);
    scripts = scripts.replace(reTrimEnd, '');
    render = "\n!function(global) {\nfunction assembleComponent(croot, cpath, getRender) {\n\tconst cdef = deferredPromise([croot, cpath].join('::'));\n\tconst gc = global[croot];\n\tconst comp = gc.map[cpath];\n\tcomp.render = getRender();\n\tcomp.render._rc = true;\n\t\t// Reason for this flag _rc :\n\t\t// https://github.com/vuejs/vue-next/pull/2910#issuecomment-752980088\n\t\t// https://jsfiddle.net/Linusborg/3tkae0jd/\n\tgc.mapCache[cpath] = cdef.promise;\n\tcdef.resolve({comp: {data: comp}});\n}\n".concat(render, "\n}(").concat(jsGlobalVar, ");\n");
    formatJs(render).then(function (_ref2) {
      var code = _ref2.code;
      code = "".concat(scripts, "\n<script>\n").concat(code, "\n</script>\n");
      cbTree(printErr, code);
    })["catch"](function (err) {
      cbTree(err || printErr);
    });
  }
}

;